﻿// -*- C++ -*-
/*!
 * @file  ArUcoOutput2Test.cpp
 * @brief ${rtcParam.description}
 * @date $Date$
 *
 * $Id$
 */

#include "ArUcoOutput2Test.h"

// Module specification
// <rtc-template block="module_spec">
static const char* arucooutput2_spec[] =
  {
    "implementation_id", "ArUcoOutput2Test",
    "type_name",         "ArUcoOutput2Test",
    "description",       "${rtcParam.description}",
    "version",           "1.0.0",
    "vendor",            "rsdlab",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.x_max", "0",
    "conf.default.x_min", "0",
    "conf.default.y_max", "0",
    "conf.default.y_min", "0",

    // Widget
    "conf.__widget__.x_max", "text",
    "conf.__widget__.x_min", "text",
    "conf.__widget__.y_max", "text",
    "conf.__widget__.y_min", "text",
    // Constraints

    "conf.__type__.x_max", "double",
    "conf.__type__.x_min", "double",
    "conf.__type__.y_max", "double",
    "conf.__type__.y_min", "double",

    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
ArUcoOutput2Test::ArUcoOutput2Test(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_InPose3DIn("InPose3D", m_InPose3D),
    m_OutPose3DOut("OutPose3D", m_OutPose3D),
    m_OutArUcoIDOut("OutArUcoID", m_OutArUcoID)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
ArUcoOutput2Test::~ArUcoOutput2Test()
{
}



RTC::ReturnCode_t ArUcoOutput2Test::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("OutPose3D", m_OutPose3DIn);
  addInPort("OutArUcoID", m_OutArUcoIDIn);
  
  // Set OutPort buffer
  addOutPort("InPose3D", m_InPose3DOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("x_max", m_x_max, "0");
  bindParameter("x_min", m_x_min, "0");
  bindParameter("y_max", m_y_max, "0");
  bindParameter("y_min", m_y_min, "0");
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ArUcoOutput2Test::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArUcoOutput2Test::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArUcoOutput2Test::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t ArUcoOutput2Test::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t ArUcoOutput2Test::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t ArUcoOutput2Test::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t ArUcoOutput2Test::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArUcoOutput2Test::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArUcoOutput2Test::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArUcoOutput2Test::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t ArUcoOutput2Test::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void ArUcoOutput2TestInit(RTC::Manager* manager)
  {
    coil::Properties profile(arucooutput2_spec);
    manager->registerFactory(profile,
                             RTC::Create<ArUcoOutput2Test>,
                             RTC::Delete<ArUcoOutput2Test>);
  }
  
};


