﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-
"""
 @file PythonUIComponent.py
 @brief ModuleDescription
 @date $Date$


"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

import sys
import Tkinter
import tkFont as font

# global 
#oval_x = 100
#oval_y = 100
#oval_width = 100
#oval_height = 100
arco_raw = []
arco_plt = []
arco_id_list = []
g_flag = False
draw_flag = False


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
pythonuicomponent_spec = ["implementation_id", "PythonUIComponent", 
		 "type_name",         "PythonUIComponent", 
		 "description",       "ModuleDescription", 
		 "version",           "1.0.0", 
		 "vendor",            "ysuga_net", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 "conf.default.debug", "0",

		 "conf.__widget__.debug", "text",

         "conf.__type__.debug", "int",

		 ""]
# </rtc-template>

##
# @class PythonUIComponent
# @brief ModuleDescription
#
#
class PythonUIComponent(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	#
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_pose = OpenRTM_aist.instantiateDataType(RTC.TimedPose2D)
		self._CurrentPoseIn = OpenRTM_aist.InPort("CurrentPose", self._d_pose) # Kobuki position

		self._d_id = OpenRTM_aist.instantiateDataType(RTC.TimedLong)
		self._ArUcoIDIn = OpenRTM_aist.InPort("ArUcoID", self._d_id) # ArUco id

		self._d_relative_pose = OpenRTM_aist.instantiateDataType(RTC.TimedPose3D)
		self._RelativePoseIn = OpenRTM_aist.InPort("RelativePose", self._d_relative_pose) # distance between Aruco marker and Kobuki

		self._d_flag = OpenRTM_aist.instantiateDataType(RTC.TimedBoolean)
		self._StopFlagIn = OpenRTM_aist.InPort("StopFlag", self._d_flag) # Flag Move or Stops


		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		"""
		 - Name:  debug
		 - DefaultValue: 0
	    """
		self._debug = [0]
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry()
	#
	# @return RTC::ReturnCode_t
	#
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		self.bindParameter("debug", self._debug, "0")
		
		# Set InPort buffers
		self.addInPort("CurrentPose",self._CurrentPoseIn)
		self.addInPort("ArUcoID",self._ArUcoIDIn)
		self.addInPort("RelativePose",self._RelativePoseIn)
		self.addInPort("StopFlag",self._StopFlagIn)
		
		# Set OutPort buffers
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		
		return RTC.RTC_OK
	
	###
	##
	## The finalize action (on ALIVE->END transition)
	## formaer rtc_exiting_entry()
	##
	## @return RTC::ReturnCode_t
	#
	##
	#def onFinalize(self):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The startup action when ExecutionContext startup
	## former rtc_starting_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The shutdown action when ExecutionContext stop
	## former rtc_stopping_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	##
	#
	# The activated action (Active state entry action)
	# former rtc_active_entry()
	#
	# @param ec_id target ExecutionContext Id
	#
	# @return RTC::ReturnCode_t
	#
	#
	def onActivated(self, ec_id):
	
		return RTC.RTC_OK
	
	##
	#
	# The deactivated action (Active state exit action)
	# former rtc_active_exit()
	#
	# @param ec_id target ExecutionContext Id
	#
	# @return RTC::ReturnCode_t
	#
	#
	def onDeactivated(self, ec_id):
	
		return RTC.RTC_OK
	
	##
	#
	# The execution action that is invoked periodically
	# former rtc_active_do()
	#
	# @param ec_id target ExecutionContext Id
	#
	# @return RTC::ReturnCode_t
	#
	#
	def onExecute(self, ec_id):
		if self._CurrentPoseIn.isNew():
		   kobuki_pos = self._CurrentPoseIn.read() # kobuki_pos(x, y) <TimedPose2D>
		   print kobuki_pos.data.position.x

		if self._ArUcoIDIn.isNew():
		   aruco_id = self._ArUcoIDIn.read()	# <TimedLong>
		   print aruco_id.data
		
		if self._RelativePoseIn.isNew():
		   kobuki_relative_pos = self._RelativePoseIn.read() # between kobuki and aruco marker pos(x, y, z) <TimedPose3D>

		   oval_x = kobuki_pos.data.position.x							 # plot oval center pos x
		   oval_y = kobuki_relative_pos.data.position.z					 # plot oval center pos y
		   id = aruco_id.data
		   print "x      y       id"
		   print oval_x, oval_y, id

		   global arco_id_list
		   if id not in arco_id_list:
			   arco_id_list.append(id)
			   print arco_id_list
			   global arco_raw
			   arco_raw.append([id, oval_x, oval_y])
			   #print arco_raw

			   global arco_plt
			   arco_plt.append([oval_x-0.03, oval_y+0.03, oval_x+0.03, oval_y-0.03])

		if self._StopFlagIn.isNew():
		   flag = self._StopFlagIn.read()					 # kobuki move:False stop:True <TimedBoolean>
		   global draw_flag
		   if draw_flag==False and flag.data==True:
			   global g_flag
			   g_flag = True

			   print "finished exe"

		return RTC.RTC_OK

	###
	##
	## The aborting action when main logic error occurred.
	## former rtc_aborting_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The error action in ERROR state
	## former rtc_error_do()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The reset action that is invoked resetting
	## This is same but different the former rtc_init_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The state update action that is invoked after onExecute() action
	## no corresponding operation exists in OpenRTm-aist-0.2.0
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##

	##
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The action that is invoked when execution context's rate is changed
	## no corresponding operation exists in OpenRTm-aist-0.2.0
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	


def PythonUIComponentInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=pythonuicomponent_spec)
    manager.registerFactory(profile,
                            PythonUIComponent,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    PythonUIComponentInit(manager)

    # Create a component
    comp = manager.createComponent("PythonUIComponent")

def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager(True)

	height_num = 173
	weight_num = 222

	def plot():
	# Plot arco marker point
		global g_flag
		if g_flag==False:
			global arco_plt
			#print "plot place list"
			#print arco_plt

			for i, pos in enumerate(arco_plt):
				print i, 'in plot loop'
				print i, 'oval position:', int(pos[0]*weight_num), 450-int(pos[1]*height_num)+50, int(pos[2]*weight_num), 450-int(pos[3]*height_num)+50
				canvas.create_oval(int(pos[0]*weight_num), 450-int(pos[1]*height_num)+50, int(pos[2]*weight_num), 450-int(pos[3]*height_num)+50, fill="blue", tag="oval")
		root.after(10, plot)


	def draw_lines(event):
    # Draw lines if button pressed
		global arco_raw
		arco_raw.sort()
		L = len(arco_raw)
		for i in range(L-1):
			canvas.create_line(int(arco_raw[i][1]*weight_num), 450-int(arco_raw[i][2]*height_num)+50, int(arco_raw[i+1][1]*weight_num), 450-int(arco_raw[i+1][2]*height_num)+50)
        # ommit append arco_raw data
		canvas.create_line(int(arco_raw[L-1][1]*weight_num), 450-int(arco_raw[L-1][2]*height_num)+50, int(arco_raw[0][1]*weight_num), 450-int(arco_raw[0][2]*height_num)+50)
	
	def finished():
    # Draw finished label and button
		global g_flag
		if g_flag==True:
			global draw_flag

			if draw_flag==False:
				print "Finished main"
        		#label
				font1 = font.Font(family="Helvetica", size=20, weight="bold")
				finLbl = Tkinter.Label(root, text="Finished!", bg="yellow", font=font1)
				finLbl.place(x=450, y=10)

        		#button
				drawBtn = Tkinter.Button(root, text="Draw")
				drawBtn.bind("<Button-1>", draw_lines)
				drawBtn.place(x=450, y=450)

				draw_flag = True
		root.after(10, finished)

	root = Tkinter.Tk()
	root.title("Dot to Dot")
	root.geometry("1000x500")

	canvas = Tkinter.Canvas(root, bg = "white", width = 800, height = 450)
	canvas.create_rectangle(50, 50, 750, 400, outline="black", width=5)

	root.after(10, plot)
	root.after(10, finished)


	canvas.pack()
	root.mainloop()

if __name__ == "__main__":
	main()