﻿// -*- C++ -*-
/*!
 * @file  moveCommander2Test.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "moveCommander2Test.h"

// Module specification
// <rtc-template block="module_spec">
static const char* movecommander2_spec[] =
  {
    "implementation_id", "moveCommander2Test",
    "type_name",         "moveCommander2Test",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.speed_foeward", "0.1",
    "conf.default.speed_round", "0.2",
    "conf.default.threshold_forward", "300",
    "conf.default.threshold_side", "500",
    "conf.default.error_rate", "0.001",

    // Widget
    "conf.__widget__.speed_foeward", "text",
    "conf.__widget__.speed_round", "text",
    "conf.__widget__.threshold_forward", "text",
    "conf.__widget__.threshold_side", "text",
    "conf.__widget__.error_rate", "text",
    // Constraints

    "conf.__type__.speed_foeward", "double",
    "conf.__type__.speed_round", "double",
    "conf.__type__.threshold_forward", "int",
    "conf.__type__.threshold_side", "int",
    "conf.__type__.error_rate", "double",

    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
moveCommander2Test::moveCommander2Test(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_inURGIn("inURG", m_inURG),
    m_inConsoleIn("inConsole", m_inConsole),
    m_outToKobukiOut("outToKobuki", m_outToKobuki),
    m_outToViewOut("outToView", m_outToView),
    m_outToPlotOut("outToPlot", m_outToPlot)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
moveCommander2Test::~moveCommander2Test()
{
}



RTC::ReturnCode_t moveCommander2Test::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("outToKobuki", m_outToKobukiIn);
  addInPort("outToView", m_outToViewIn);
  addInPort("outToPlot", m_outToPlotIn);
  
  // Set OutPort buffer
  addOutPort("inURG", m_inURGOut);
  addOutPort("inConsole", m_inConsoleOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("speed_foeward", m_speed_foeward, "0.1");
  bindParameter("speed_round", m_speed_round, "0.2");
  bindParameter("threshold_forward", m_threshold_forward, "300");
  bindParameter("threshold_side", m_threshold_side, "500");
  bindParameter("error_rate", m_error_rate, "0.001");
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t moveCommander2Test::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t moveCommander2Test::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t moveCommander2Test::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t moveCommander2Test::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t moveCommander2Test::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t moveCommander2Test::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t moveCommander2Test::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t moveCommander2Test::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t moveCommander2Test::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t moveCommander2Test::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t moveCommander2Test::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void moveCommander2TestInit(RTC::Manager* manager)
  {
    coil::Properties profile(movecommander2_spec);
    manager->registerFactory(profile,
                             RTC::Create<moveCommander2Test>,
                             RTC::Delete<moveCommander2Test>);
  }
  
};


